#Projekt 10 - Alarm antywłamaniowy z powiadomieniem przez email 

#import potrzebnych bibliotek
from gpiozero import LED, Button, MotionSensor
import smtplib
from email.mime.text import MIMEText
from signal import pause

#tworzenie obiektów odnoszących się do każdej diody LED, przycisku i czujnika PIR
led_status = LED(17)
led_triggered = LED(18)
button = Button(2)
pir = MotionSensor(4)

#sterowanie zmiennymi
stan_czujnika_ruchu = False
email_wyslany = False

#uzbrajanie lub rozbrajanie czujnika PIR
def uzbroj_czujnik_ruchu():
    global email_wyslany
    global stan_czujnika_ruchu
    if stan_czujnika_ruchu == True:
        stan_czujnika_ruchu = False
        led_status.off()
        led_triggered.off()
    else:
        stan_czujnika_ruchu = True
        email_wyslany = False
        led_status.on()

#wysyłanie e-maila, gdy ruch został wykryty i czujnik PIR jest uzbrojony
def wyslij_email():
    global email_wyslany
    global stan_czujnika_ruchu
    if(stan_czujnika_ruchu == True and email_wyslany == False):
        #zastąp trzy następne wiersze swoimi poświadczeniami
        adres_email_nadawcy = 'TWÓJ_EMAIL@gmail.com'
        haslo_email_nadawcy = 'TWOJE_HASŁO_EMAIL'
        adres_email_odbiorcy = 'TWÓJ_INNY_EMAIL@gmail.com'

        #wysyłanie wiadomości e-mail
        tresc = 'W pomieszczeniu wykryto ruch.'
        msg = MIMEText(tresc)

        #ustawienie nadawcy i odbiorcy
        msg['From'] = adres_email_nadawcy
        msg['To'] = adres_email_odbiorcy

        #ustawienie tematu wiadomości
        msg['Subject'] = 'ALARM ANTYWŁAMANIOWY'

        #połączenie z serwerem i wysłanie wiadomości
        #edytuj ten wiersz z użyciem szczegółów serwera dostawcy SMTP
        server = smtplib.SMTP('smtp.gmail.com', 587)
        #zakomentuj ten wiersz, jeśli twój dostawca nie używa TLS
        server.starttls()
        server.login(adres_email_nadawcy, haslo_email_nadawcy)
        server.sendmail(adres_email_nadawcy,
        adres_email_odbiorcy, msg.as_string())
        server.quit()
        email_wyslany = True
        led_triggered.on()
        print('Email wysłany')

#przypisanie funkcji, która jest uruchomiona po naciśnięciu przycisku
button.when_pressed = uzbroj_czujnik_ruchu
#przypisanie funkcji, która jest wykonywana po wykryciu ruchu
pir.when_motion = wyslij_email

pause()
