#Projekt 12 - Rejestrator danych o temperaturze i wilgotności 

#import potrzebnych bibliotek
import Adafruit_DHT
import time

#wstaw lub usuń znak komentarza w poniższych wierszach
#zależnie od czujnika
#czujnik = Adafruit_DHT.DHT11
czujnik = Adafruit_DHT.DHT22
#czujnik = Adafruit_DHT.AM2302

#pin DHT połączony z GPIO 4
pin_czujnika = 4

#tworzenie zmiennej sterującej całą pętlą
dziala = True

#plik new.txt utworzony z nagłówkiem
file = open('odczyty_czujnika.txt', 'w')
file.write('czas i data, temperatura, wilgotnosc\n')

#pętla bez końca
while dziala:
    try:
        #odczyt wilgotności i temperatury
        wilgotnosc, temperatura = Adafruit_DHT.read_retry(czujnik, pin_czujnika)

       #usuń znak komentarza w wierszu poniżej, aby przeliczyć na Fahrenheity
       #temperatura = temperatura * 9/5.0 + 32

        #czasami nie uzyskamy odczytu i wyniki będą puste (null)
        #następna instrukcja gwarantuje, że zapisuje tylko poprawne odczyty
        if wilgotnosc is not None and temperatura is not None:
            #print temperatura and wilgotnosc
            print('Temperatura = ' + str(temperatura) + ', Wilgotnosc = ' + str(wilgotnosc))
            #zapisywanie czasu, daty, temperatury i wilgotnosci w pliku .txt
            file.write(time.strftime('%H:%M:%S %d/%m/%Y') + ', ' +
                str(temperatura) + ', '+ str(wilgotnosc) + '\n')
        else:
            print('Nie udalo sie uzyskac odczytu. Sprobuj ponownie!')
        #czekanie 10 s między każdym odczytem czujnika
        time.sleep(10)
    #Jeśli KeyboardInterrupt jest uruchomione, zatrzymanie pętli i zamknięcie pliku close .txt
    except KeyboardInterrupt:
        print ('Program zatrzymany')
        running = False
        file.close()
