#Project 16 - Łączenie elektroniki z WWW

#import potrzebnych bibliotek
from gpiozero import LED
from flask import Flask, render_template, request

#tworzenie obiektu Flask
app = Flask(__name__)

#tworzenie obiektu, który odnosi się do przekaźnika
relay = LED(17)
#wyłączanie przekaźnika; pamiętamy, że przekaźnik działa z odwrotną logiką
relay.on()
#zapisywanie aktualnego stanu przekaźnika
stan_przekaznika = 'Przekaźnik jest wyłączony'

#wyświetlanie głównej strony WWW
@app.route('/')
def main():
   global stan_przekaznika
   #przekazywanie stanu przekaźnika do index.html i zwracanie go użytkownikowi
   return render_template('index.html', relay_state=stan_przekaznika)

#wykonywanie control(), gdy ktoś naciska przyciski wł/wył
@app.route('/<action>')
def control(action):
   global stan_przekaznika
   #jeśli cześcią URL jest 'on', włączamy przekaźnik
   if action == 'on':
   #włączanie przekaźnika
      relay.off()
      #zapisywanie stanu przekaźnika 
      relay_state = 'Przekaźnik jest włączony'
   if action == 'off':
      relay.on()
      relay_state = 'Przekaźnik jest wyłączony'

   #przekazywanie stanu przekaźnika do index.html i zwracanie go użytkownikowi
   return render_template('index.html', relay_state=stan_przekaznika)

#uruchomienie serwera WWW na lokalnym hoście na porcie 80
if __name__ == '__main__':
   app.run(host='0.0.0.0', port=80, debug=True)
