#Projekt 5 - Paski tęczowego światła

#na podstawie przykładu testu wartości brzegowych biblioteki NeoPixel  Tony’ego DiCola

#importowanie potrzebnych bibliotek 
from neopixel import *
from time import sleep
from gpiozero import Button, MCP3008

#konfiguracja paska LED 
LED_LICZBA = 14 #liczba pikseli LED 
LED_PIN = 18 #pin GPIO połączony z pikselami (musi obsługiwać PWM!)
LED_CZEST_HZ = 800000 #częstotliwość sygnału LED w Hz (zwykle 800 kHz)
LED_DMA = 5 #kanał DMA do użycia w celu generowania sygnalu (spróbuj 5)
LED_ODWROC = False #ustaw True, aby odwrócić sygnał

#tworzenie obiektów, które odnoszą się do kanałów 0 i 1 MCP3008 
pot_jasnosc = MCP3008(0)
pot_szybkosc = MCP3008(1)

#łączenie przycisku z GPIO 2, wyciągnięcie
przycisk_start = Button(2)

#zmienna sterująca działaniem animacji 
animacja_uruchomiona = False

#generowanie kolorów tęczy na pozycjach 0-255 
def kolo(poz):
    if poz < 85:
        return Color(poz * 3, 255 - poz * 3, 0)
    elif poz < 170:
        poz -= 85
        return Color(255 - poz * 3, 0, poz * 3)
    else:
        poz -= 170
        return Color(0, poz * 3, 255 - poz * 3)

#rysowanie tęczy, która równomiernie rozkłada się na wszystkich pikselach 
def cyklTeczy(strip):
    for j in range(256):
        for i in range(strip.numPixels()):
            strip.setPixelColor(i, kolo((int(i * 256 / strip.numPixels()) + j) & 255))
        strip.show()
        sleep((pot_szybkosc.value*40)/1000.0)

#funkcja, która rozpoczyna i zatrzymuje animację 
def start_animacji():
    global animacja_uruchomiona
    if animacja_uruchomiona == True:
        animacja_uruchomiona = False
    else:
        animacja_uruchomiona = True

#przypisywanie funkcji, która działa, gdy przycisk jest naciśnięty
przycisk_start.when_pressed = start_animacji

#tworzenie obiekt NeoPixel z odpowiednią konfiguracją
strip = Adafruit_NeoPixel(LED_COUNT, LED_PIN, LED_FREQ_HZ, LED_DMA, LED_INVERT, int(pot_brightness.value*255))

#inicjalizacja paska
strip.begin()
while True:
    if animacja_uruchomiona == True:
        #ustawienie jasności paska LED 
        strip.setBrightness(int(pot_jasnosc.value*255))
        cyklTeczy(strip)
