#Projekt 7 - Mini pogodynka

#importowanie potrzebnych bibliotek
import time
import Adafruit_SSD1306
import requests

from PIL import Image
from PIL import ImageDraw
from PIL import ImageFont

#Konfiguracja pinu Raspberry Pi 
RST = 24

#wyświetlacz 128x32 ze sprzętowym I2C
#disp = Adafruit_SSD1306.SSD1306_128_32(rst=RST)

#wyświetlacz 128x64 ze sprzętowym I2C
disp = Adafruit_SSD1306.SSD1306_128_64(rst=RST)


#set your unique OpenWeatherMap.org URL
open_weather_map_url = 'http://api.openweathermap.org/data/2.5/weather?q=Porto,PT&APPID=801d2603e9f2e1c70e042e4f5f6e0381'

#inicjalizacja wyświetlacza
disp.begin()

while True:
    #czyszczenie ekranu
    disp.clear()
    disp.display()

    #tworzenie pustego obrazu do rysowania
    #sprawdzanie, czy obraz jest tworzony w trybie '1' dla koloru 1 bitowego
    szerokosc = disp.width
    wysokosc = disp.height
    obraz = Image.new('1', (szerokosc, wysokosc))

    #uzyskanie obiektu do rysowania obrazu
    draw = ImageDraw.Draw(obraz)

    #rysowanie czarnego wypełnionego pola, aby oczyścić obraz
    draw.rectangle((0,0,szerokosc,wysokosc), outline=0, fill=0)

    #definiowanie stałych do definiowania obszaru rysowania
    wypelnienie = 2
    top = wypelnienie
    
    #przesuniecie z lewej do prawej, zachowując ślad bieżącego x dla rysowanego tekstu
    x = wypelnienie

    #ładowanie domyślnej czcionki
    czcionka = ImageFont.load_default()

    #żądanie danych o pogodzie openWeatherMap.org 
    dane_o_pogodzie = requests.get(open_weather_map_url)

    #wyświetlanie położenia 
    polozenie = dane_o_pogodzie.json().get('name') + ' - ' + dane_o_pogodzie.json().get('sys').get('country')
    draw.text((x, top), location,  font=font, fill=255)

    #display opis
    opis = 'Desc ' + dane_o_pogodzie.json().get('weather')[0].get('main')
    draw.text((x, top+10), opis,  font=font, fill=255)

    #temperatura
    surowa_temperatura = dane_o_pogodzie.json().get('main').get('temp')-273.15

    #temperatura w stopniach Celsjusza
    temperatura = 'Temp ' + str(surowa_temperatura) + '*C'
    
    #usunięcie komentarza dla temperatury w stopniach Fahrenheita
    #temperatura = 'Temp ' + str(surowa_temperatura*(9/5.0)+32) + '*F'

    #wyświetlenie temperatury
    draw.text((x, top+20), temperatura, font=czcionka, fill=255)

    #wyświetlenie ciśnienia 
    cisnienie = 'Pres ' + str(dane_o_pogodzie.json().get('main').get('pressure')) + 'hPa'
    draw.text((x, top+30), cisnienie, font=czcionka, fill=255)

    #wyświetlenie wilgotności 
    wilgotnosc = 'Wilg ' + str(dane_o_pogodzie.json().get('main').get('humidity')) + '%'
    draw.text((x, top+40), wilgotnosc, font=czcionka, fill=255)

    #wyświetlenie wiatru
    wiatr = 'Wiatr ' + str(dane_o_pogodzie.json().get('wind').get('speed')) + 'mps ' + str(dane_o_pogodzie.json().get('wind').get('deg')) + '*'
    draw.text((x, top+50), wiatr, font=czcionka, fill=255)

    #wyświetlenie obrazu
    disp.image(obraz)
    disp.display()
    time.sleep(10)
