#Projekt 8 - Pong z Sense HAT

#na podstawie przykładu raspberrypi.org Sense HAT Pong

#import potrzebnych bibliotek
from random import randint
from time import sleep

#użyj tego wiersza, jeśli korzystasz z płyty Sense HAT
from sense_hat import SenseHat

#odkomentuj wiersz poniżej, jeśli korzystasz z emulatora
#from sense_emu import SenseHat

#utwórz obiekt o nazwie sense
sense = SenseHat()

#ustawianie położenia rakietki, losowego położenia piłki i prędkości
y = 4
polozenie_pilki = [int(randint(2,6)), int(randint(1,6))]
predkosc_pilki = [1, 1]

#kolor czerwony
X = [255, 0, 0]
#bez koloru
N = [0, 0, 0]

#tablica smutnej twarzy
smutna_twarz = [
N, N, X, X, X, X, N, N,
N, X, N, N, N, N, X, N,
X, N, X, N, N, X, N, X,
X, N, N, X, N, N, N, X,
X, N, N, X, N, N, N, X,
X, N, X, N, N, X, N, X,
N, X, N, N, N, N, X, N,
N, N, X, X, X, X, N, N
]

#narysuj rakietkę w położeniu y
def rysuj_rakietke():
    sense.set_pixel(0, y, 0, 255, 0)
    sense.set_pixel(0, y+1, 0, 255, 0)
    sense.set_pixel(0, y-1, 0, 255, 0)

#przesuń rakietkę w górę
def ruch_w_gore(event):
    global y
    if y > 1 and event.action=='pressed':
        y -= 1

#przesuń rakietkę w dół
def ruch_w_dol(event):
    global y
    if y < 6 and event.action=='pressed':
        y += 1

#przesuń piłkę do następnego położenia
def rysuj_pilke():
    #piłka wyświetlona w bieżącym położeniu
    sense.set_pixel(polozenie_pilki[0], polozenie_pilki[1], 75, 0, 255)
    #następne położenie piłki
    polozenie_pilki[0] += predkosc_pilki[0]
    polozenie_pilki[1] += predkosc_pilki[1]
    #jeśli piłka uderzy w sufit, oblicz następne położenie
    if polozenie_pilki[0] == 7:
        predkosc_pilki[0] = -predkosc_pilki[0]
    #jeśli piłka uderzy w ścianę, oblicz następne położenie
    if polozenie_pilki[1] == 0 or polozenie_pilki[1] == 7:
        predkosc_pilki[1] = -predkosc_pilki[1]
    #jeśli piłka osiągnie położenie 0, gracz przegrywa i gra się kończy
    if polozenie_pilki[0] == 0:
        sleep(0.25)
        sense.set_pixels(smutna_twarz)
        quit()
    #eśli piłka uderzy w rakietkę, oblicz następne położenie
    if polozenie_pilki[0] == 1 and y - 1 <= polozenie_pilki[1] <= y+1:
        predkosc_pilki[0] = -predkosc_pilki[0]

#gdy joystick przesuwa się w górę lub w dół, uruchom odpowiednią funkcję
sense.stick.direction_up = ruch_w_gore
sense.stick.direction_down = ruch_w_dol

#uruchamianie gry
while True:
    sense.clear()
    rysuj_rakietke()
    rysuj_pilke()
    sleep(0.25)
